SystemOrganization addCategory: #'FuelTools-Debugger'!

!SpecDebuggerToolbar methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 10:23'!
serializeStack
	self flag: 'Move this to the debugger class'.
	self session serializeStack! !

!DebugSession class methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 10:28'!
encodeDebugInformationOn: aSerializer
	| str |
	
	str := String new writeStream. 
	str print: Date today; space; print: Time now.
	aSerializer at: #Timestamp putAdditionalObject: str contents. 
	
	str := String new writeStream. 
	str nextPutAll: 'VM: ';
		nextPutAll: Smalltalk os name asString;
		nextPutAll: ' - ';	
		nextPutAll: Smalltalk os subtype asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk os version asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk vm version asString.
	aSerializer at: #VM putAdditionalObject: str contents. 
		
	str := String new writeStream. 
	str nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: Smalltalk lastUpdateString asString;
		nextPutAll: ']'.
	aSerializer at: #Image putAdditionalObject: str contents.! !

!DebugSession class methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 23:49'!
serializeTestFailureContext: aContext toFileNamed: aFilename
	| serializer |
	
	serializer := FLSerializer newDefault.
	self encodeDebugInformationOn: serializer. 
	serializer addPostMaterializationAction: [ :materialization | 
		Smalltalk tools debugger
			openOn: Processor activeProcess 
			context: materialization root 
			label: 'External stack' 
			contents: nil 
			fullView: false ].
		
	serializer
		" use the sender context, generally the current context is not interesting"
		serialize: aContext
		toFileNamed: aFilename! !

!DebugSession methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 10:44'!
serializeStack
	| date fileName |
	"Serialize a portion of the current stack trace using fuel.."
	date := DateAndTime now.
	
	fileName := String streamContents: [ :s|
		s 
			<< 'Debugger-Stack-';
			<< self interruptedContext receiver class theNonMetaClass name;
			<< '-'.
		date printYMDOn: s.
		s 
			<< '-'; print: date hour24; print: date minute; print: date second;
			<< '.fuel'].

	[ self class 
		serializeTestFailureContext: self interruptedContext copyStack		
		toFileNamed: fileName	] 
	on: Error 
	do: [:err| "simply continue..." ].! !

!Debugger class methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 10:32'!
encodeDebugInformationOn: aSerializer
	| str |
	
	str := String new writeStream. 
	str print: Date today; space; print: Time now.
	aSerializer at: #Timestamp putAdditionalObject: str contents. 
	
	str := String new writeStream. 
	str nextPutAll: 'VM: ';
		nextPutAll: Smalltalk os name asString;
		nextPutAll: ' - ';	
		nextPutAll: Smalltalk os subtype asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk os version asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk vm version asString.
	aSerializer at: #VM putAdditionalObject: str contents. 
		
	str := String new writeStream. 
	str nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: Smalltalk lastUpdateString asString;
		nextPutAll: ']'.
	aSerializer at: #Image putAdditionalObject: str contents.! !

!Debugger class methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 23:49'!
serializeTestFailureContext: aContext toFileNamed: aFilename
	| serializer |
	
	serializer := FLSerializer newDefault.
	self encodeDebugInformationOn: serializer. 
	serializer addPostMaterializationAction: [ :materialization | 
		Smalltalk tools debugger
			openOn: Processor activeProcess 
			context: materialization root 
			label: 'External stack' 
			contents: nil 
			fullView: false ].
		
	serializer
		" use the sender context, generally the current context is not interesting"
		serialize: aContext
		toFileNamed: aFilename! !

!Debugger methodsFor: '*FuelTools-Debugger' stamp: 'EstebanLorenzano 2/18/2013 18:40'!
serializeStack
	| date fileName |
	"Serialize a portion of the current stack trace using fuel.."
	date := DateAndTime now.
	
	fileName := String streamContents: [ :s|
		s 
			<< 'Debugger-Stack-';
			<< self interruptedContext receiver class theNonMetaClass name;
			<< '-'.
		date printYMDOn: s.
		s 
			<< '-'; print: date hour24; print: date minute; print: date second;
			<< '.fuel'].

	[ self class 
		serializeTestFailureContext: self interruptedContext copyStack		
		toFileNamed: fileName	] 
	on: Error 
	do: [:err| "simply continue..." ].! !

!SpecDebugger class methodsFor: '*FuelTools-Debugger' stamp: 'AndreiChis 7/25/2013 10:24'!
menuFuelStackAction: aBuilder
	<contextMenu>
	<specDebuggerStackMenu>

	(aBuilder item: #'Fuel out Stack')
		selector: #serializeStack.
! !
